#include <stdio.h>

typedef struct
 {
 char Name[200];
 double offset;
 double faktor;
 int anzeige;
 } satz;

int main(int argc,char **argv)
 {
 int spalten,a,umgesetzt;
 double wert,*werte;
 FILE *config,*infile,*outfile;
 satz *feld;
 char st1[2000],*cp,*cp1,*cp2;
 
 if(argc<2)
  {
  printf("Benutzung:\nconv <rohdatei> [configdatei] [zieldatei]\n");
  return -1;
  }
 
 strcpy(st1,"config.txt");
 if(argc>2) strcpy(st1,argv[2]);
 /*Konfigurationsdatei ffnen*/
 config=fopen(st1,"r");
 if(!config)
  {
  printf("Configdatei %s nicht gefunden!\n",st1);
  return -1;
  }
 /* erste Zeile lesen */
 fgets(st1,1990,config);
 spalten=0;
 while(!feof(config))
  {
  /* nchste Zeile lesen */
  memset(st1,0,10);
  fgets(st1,1990,config);
  cp=st1;
  a=0;
  while(cp=strchr(cp+1,';')) a++;
  if (a==3) spalten++;
  }
 printf ("%d Spalten\n",spalten);
 rewind(config);
 

 /*Speicher reservieren*/
 feld=calloc(spalten,sizeof(satz));
 werte=calloc(spalten,sizeof(double));
 cp=st1;

 /* erste Zeile lesen */
 fgets(st1,1990,config);
 /*Namen einlesen*/
 for (a=0;a<spalten;a++)
  {
   fgets(st1,1990,config);
   /* CR durch Semikolon ersetzen */
   if(cp=strchr(st1,'\n')) *cp=';';
   
   cp1=strchr(st1,';');
   if(cp1) *cp1=0;
   cp1++;
   cp=st1;
   if(*cp=='"')
    {
    cp++;
    if(cp2=strchr(cp,'"')) *cp2=0;
    }
   strcpy(feld[a].Name,cp);
   cp=cp1;
   
   /* Kommas durch Punkte ersetzen*/
   while(cp1=strchr(cp1,',')) *cp1='.';

   cp1=strchr(cp,';');
   if(cp1) *cp1=0;
   cp1++;
   sscanf(cp,"%lf",&feld[a].offset);
   cp=cp1;
   
   cp1=strchr(cp,';');
   if(cp1) *cp1=0;
   cp1++;
   sscanf(cp,"%lf",&feld[a].faktor);
   cp=cp1;
   
   cp1=strchr(cp,';');
   if(cp1) *cp1=0;
   cp1++;
   sscanf(cp,"%d",&feld[a].anzeige);
   cp=cp1;
   
  } 
 fclose(config);
 printf("Spalte               Name               Offset                FaktorAnz\n");
 for(a=0;a<spalten;a++)
  {
  printf("%4d %20s %20lf %20lf %3d\n",a,feld[a].Name,feld[a].offset,feld[a].faktor,
                                       feld[a].anzeige);
  }

 printf("Beginne mit konvertieren...\n");
 
 /* Versuchen Arbeitsdatei zu ffnen */
 infile=fopen(argv[1],"r");
 if(!infile)
  {
  printf("Eingabedatei %s konnte nicht geffnet werden!\n",argv[1]);
  return -1;
  }
 
 
 /* Ausgabedatei ffnen */
 strcpy(st1,"temp.csv");
 if(argc>3) strcpy(st1,argv[3]);
 outfile=fopen(st1,"w");

 /*Kopfzeile schreiben*/
 fprintf(outfile,"Datum;Zeit");
 for(a=0;a<spalten;a++)
  {
  if(feld[a].anzeige) fprintf(outfile,";%s",feld[a].Name);
  }
 fprintf(outfile,"\n");
 
 /* Werte konvertieren */
 
 while(!feof(infile))
  {
   memset(st1,0,20);
   fgets(st1,1990,infile);
   if(strlen(st1)>spalten)
   {
   /* Wagenrcklauf durch Komma ersetzen */
   cp=strchr(st1,'\n');
   if (cp) *cp=',';
   
   /* Kommas zhlen */
   a=0;
   cp=st1;
   while (cp=strchr(cp+1,',')) a++;
   if(a>spalten)
   {

   cp=strchr(st1,',');
   *cp=0;
   cp++;
   /* Datum schreiben */
   fprintf(outfile,"%s;",st1);
   cp1=strchr(cp,',');
   if(!cp1)
    {
    printf("Formatfehler");
    return -1;
    }
   *cp1=0;
   cp1++;
   
   /* Uhrzeit schreiben */
   fprintf(outfile,"%s",cp);
   
   /* Werte bertragen */
   umgesetzt=0;
   for(a=0;a<spalten-1;a++)
    {
    cp=strchr(cp1,',');
    if(!cp) break;
    *cp=0;
    cp++;
    sscanf(cp1,"%lf",&wert);
    /* Jetzt die Berechnungen */
    wert=feld[a].faktor*(wert-feld[a].offset);
    if(feld[a].anzeige) fprintf(outfile,";%lf",wert);
    umgesetzt++;
    cp1=cp;
    }
    }
    fprintf(outfile,"\n");
    }
  }

 fclose(outfile);
 fclose(infile);
 free(feld);
 free(werte);
 return 0;
 }
